commit 047b700fb08dfdc6c8ce2ae6554822cac0cd85b5
Author: Jason Merrill <jason@redhat.com>
Date:   Sat Nov 13 23:16:46 2021

    c++: is_this_parameter and coroutines proxies
    
    Compiling coroutines/pr95736.C with the implicit constexpr patch broke
    because is_this_parameter didn't recognize the coroutines proxy for 'this'.
    
    gcc/cp/ChangeLog:
    
            * semantics.c (is_this_parameter): Check DECL_HAS_VALUE_EXPR_P
            instead of is_capture_proxy.

diff --git a/gcc/cp/semantics.c b/gcc/cp/semantics.c
index 6da30d12c53..9dc10e7d759 100644
--- a/gcc/cp/semantics.c
+++ b/gcc/cp/semantics.c
@@ -10669,7 +10669,8 @@ is_this_parameter (tree t)
 {
   if (!DECL_P (t) || DECL_NAME (t) != this_identifier)
     return false;
-  gcc_assert (TREE_CODE (t) == PARM_DECL || is_capture_proxy (t)
+  gcc_assert (TREE_CODE (t) == PARM_DECL
+	      || (TREE_CODE (t) == VAR_DECL && DECL_HAS_VALUE_EXPR_P (t))
 	      || (cp_binding_oracle && TREE_CODE (t) == VAR_DECL));
   return true;
 }

